#define LOCK(fd) (flock(fd,(LOCK_EX|LOCK_NB) ) >= 0)
typedef struct { 
   char day[100][100]; 
   } WEEK;


//----------
// get the day of week  
int get_day(char *day)
{
if (strstr(day,"Mon")!=NULL) return 0;
if (strstr(day,"Tue")!=NULL) return 1;
if (strstr(day,"Wed")!=NULL) return 2;
if (strstr(day,"Thu")!=NULL) return 3;
if (strstr(day,"Fri")!=NULL) return 4;
if (strstr(day,"Sat")!=NULL) return 5;
if (strstr(day,"Sun")!=NULL) return 6;
return -1;
}
// get parametr
char* get_param(char* parametr,int number,char devisor)
{ int prom=1,k=0,i=0;
  char res[100];
      for (i=0;i<=strlen(parametr);i++)
       {
	  if (prom==number) {res[k]=parametr[i];k++;}
	  if ((parametr[i]==' ')||(parametr[i]==devisor)) prom++;
       }
res[k-1]='\0';
return res;
}

int start_time(char *start)
{ return 0;}
char * get_time(void)
{time_t t; t = time(&t);
return ctime(&t);
}

// read config file from standard config file
int read_config(char* price,char* price2)
{
FILE *src,*otp;
char temp[255];int k=0;
src=fopen("/etc/card/price_priv","r");
 if (src==NULL) return -1;
    while(!feof(src))
    {
     fgets(temp,255,src);
     price[atoi(get_param(temp,1,':'))]=atoi(get_param(temp,2,' '));
    }
fclose(src);
otp=fopen("/etc/card/price_org","r");
 if (otp==NULL) return -1;
    while(!feof(otp))
    {
     fgets(temp,255,otp);
     price2[atoi(get_param(temp,1,':'))]=atoi(get_param(temp,2,' '));
    }
fclose(otp);
return 0;
}

//----------
int read_profile(char *user,WEEK* week)
{
FILE *src;
char temp[255];
char path[200];
char test[255];
int org=0;
strcpy(path,"/home/");
strcat(path,user);
strcat(path,"/.profile");
src=fopen(path,"r");
 if (src==NULL) return -1;
    while(!feof(src))
    {
     fgets(temp,255,src);
     if (strstr(temp,"ORG")!=NULL)       org=1;
     if (strstr(temp,"org")!=NULL)	 org=1;
     if (strstr(temp,"Poned")!=NULL)     strcpy(week->day[0],get_param(temp,2,0x09));
     if (strstr(temp,"Vtor")!=NULL)      strcpy(week->day[1],get_param(temp,2,0x09));
     if (strstr(temp,"Sreda")!=NULL)     strcpy(week->day[2],get_param(temp,2,0x09));
     if (strstr(temp,"Chetv")!=NULL)     strcpy(week->day[3],get_param(temp,2,0x09));
     if (strstr(temp,"Pyatn")!=NULL)     strcpy(week->day[4],get_param(temp,2,0x09));
     if (strstr(temp,"Sub")!=NULL)       strcpy(week->day[5],get_param(temp,2,0x09));
     if (strstr(temp,"Voskr")!=NULL)     strcpy(week->day[6],get_param(temp,2,0x09));
}
fclose(src);
return org;
}
float asc_cost(char* price,char* price2,int org)
{
 struct tm *tm;
 time_t curtime;
 float cps; 
 curtime= time(NULL);
 tm=localtime(&curtime);
 if (org==1) cps=(price2[tm->tm_hour])/36.0;
 else        cps=(price[tm->tm_hour])/36.0;
 return cps;
}

int lockproc(char *lock1)
 {
        struct passwd *pw1;
        char *str1;
 	int fd,fl=0;
        str1=(char *)malloc(80);
       /* pw1=(struct passwd *)malloc(sizeof(struct passwd));*/
       if((pw1=getpwnam(lock1)) == NULL) 
         {
          /*free(pw1);*/
          free(str1);
          return(0);
         };
        strcpy(str1,pw1->pw_dir);
        strcat(str1,"/.Lock");
 	if (access (str1, 0) != 0) close(creat (str1, 0600));
 
 	fd = open (str1, 1);
 	if (fd < 0) {fl++;free(str1);return(0);}
 	fcntl (fd, F_SETFD, 1);        /* close on exec */
 	if (! LOCK (fd)) { fl++;free(str1);return(0);}
 	/* don't close the lock file */
       free(str1);
       /*free(pw1);*/
       if(fl == 0) return (2);
 }
pid_t asc_ps(char *dev1)
{
pid_t pid;
int i,fl=0;
char *s1,*s2,*progname,*p1,*ps;
FILE *fin , *popen();
char buf[BUFSIZ],s3[20];
progname="pppd";
ps=(char*)malloc(40);
s1=(char*)malloc(80);
s2=(char*)malloc(80);
strcpy(ps,"/bin/ps t");
strcat(ps,dev1+8);

 	if (( fin = popen(ps,"r")) == NULL) 
		{
 	        fprintf(stderr,"Trouble to open Popen %s \n ",ps);
			exit(1);
		}
 	fgets(buf,sizeof buf,fin);
 	 while (fgets(buf,sizeof buf ,fin) != NULL)
		{
 	           buf[strlen(buf)-1]='\0';
		    s1=buf;s2="pppd";
 	           if (strstr(s1,s2) != NULL) 
				{ 
                                  fl++;
 	     			  sscanf(buf,"%d", &pid);
				  fclose(fin);
                                  return(pid);
			         break;
				 };
		};
  if (fl == 0) return (0);
}
/*------------------------------------LIMIT > 0------------------*/
int monitor(int Flag,char *dev1, float limit1,char *user1,char* price,char* price2,WEEK* week,int org)
{
struct tm *tm,*tn;
struct passwd *pw;
time_t begintime=0 , curtime=0 ,runtime;
char *progname, *ditr,*str ,accss;
int oblom=0,j=1,BR=0;
long ik=1,i;
float cost=0,cur_cost=0;
float limit,beginlim,curlim;
pid_t pid;
FILE *fin , *fp , *popen(),*otch;
char buf[BUFSIZ],s3[20];
progname="pppd";
str=(char*)malloc(90);
pw=(struct passwd *)malloc(sizeof(struct passwd));
if(( pw=getpwnam(user1)) == NULL)
 {
   if(( pid=asc_ps(dev1) ) != 0) 
     {
      kill (pid,SIGHUP);
     };
   free(pw);
   return(1);
 };
strcpy(str,pw->pw_dir);
strcat(str,"/.limit");
begintime=time(NULL);
limit=curlim=limit1;
beginlim=limit;
while (ik > 0)
  {
   ik=0;
   while (sleep(2) != 0 )
    {
     i++;
    };
   if((pid=asc_ps(dev1)) == 0 )
    {
     if((pid=asc_ps(dev1)) == 0 )
      {
      curtime=time(NULL);
      runtime=curtime-begintime;
      cost=asc_cost(price,price2,org);
      limit=beginlim-(runtime*cost*1.0);
      if ( limit <= 0) limit=0;
      strcpy(str,pw->pw_dir);
      strcat(str,"/.limit");
      if ((fp = fopen(str,"w")) == NULL )
        {
         fprintf(stderr,"LIMIT is not found \n");
        };
      fprintf(fp,"%8.2f            ",limit);
      fclose(fp);
      strcpy(str,pw->pw_dir);
      strcat(str,"/.otchet");
      tm=localtime(&begintime);
      tn=localtime(&curtime);
      if ((otch = fopen(str,"a")) == NULL )
        {
         fprintf(stderr,"Otchet nothing found \n");};
         fprintf(otch,"[%2d/%2d] %2d:%2d:%2d	-	%ld	: %8.2f	%8.2f\n",tm->tm_mon,tm->tm_mday,tm->tm_hour,tm->tm_min,tm->tm_sec,runtime,beginlim,limit);
//         fprintf(otch,"-session closed-"); 	   	 
//         for(BR=0;BR<=23;BR++) fprintf(otch,"%d-",price2[BR]);fprintf(otch,"\n");
	 fclose(otch);
         return(0);
        };
     }
   else
     {
      ik++;
      tm=localtime(&begintime);
      accss=week->day[get_day(get_param(get_time(),1,' '))][tm->tm_hour];
      curtime=time(NULL);
      runtime=curtime-begintime;
      cost=asc_cost(price,price2,org);
      /*=================================================*/
      if (cur_cost!=cost) 
      {  curlim=beginlim-(runtime*cur_cost*1.0);
         strcpy(str,pw->pw_dir);strcat(str,"/.otchet");
	 tm=localtime(&begintime);
	 tn=localtime(&curtime);	 
	 limit=beginlim-(runtime*cost*1.0);
         if ((otch = fopen(str,"a")) == NULL )
          {
           fprintf(stderr,"Otchet nothing found \n");};
	   fprintf(otch,"[%2d/%2d] %2d:%2d:%2d	-	%ld	: %8.2f	%8.2f\n",tm->tm_mon,tm->tm_mday,tm->tm_hour,tm->tm_min,tm->tm_sec,runtime,beginlim,limit);
	   fprintf(otch,"-change tarif plan-"); 	   
  // 	   for(BR=0;BR<=23;BR++) fprintf(otch,"%d ",price2[BR]);fprintf(otch,"\n");
	   fclose(otch);
	   beginlim=beginlim-(runtime*cost*1.0);
           cur_cost=cost; 
	   begintime=curtime;
	   runtime=curtime-begintime;
      }
      /*=================================================*/
      curlim=beginlim-(runtime*cost*1.0);
      if (( curlim <= 0)||(accss=='X'))
      //if ( curlim <= 0)
        {
         if (curlim<=0) limit=0;
  	 kill (pid,SIGHUP);
         strcpy(str,pw->pw_dir);
         strcat(str,"/.limit");
         if ((fp = fopen(str,"r+")) == NULL )
           {
            fprintf(stderr,"LIMIT is not found \n");
           };
         fprintf(fp,"%8.2f            ",limit);
         fclose(fp);
         strcpy(str,pw->pw_dir);
         strcat(str,"/.otchet");
	 tm=localtime(&begintime);
         if ((otch = fopen(str,"a")) == NULL )
          {
           fprintf(stderr,"Otchet nothing found \n");};
	   fprintf(otch,"[%2d/%2d] %2d:%2d:%2d	-	%ld	: %8.2f	%8.2f\n",tm->tm_mon,tm->tm_mday,tm->tm_hour,tm->tm_min,tm->tm_sec,runtime,beginlim,limit);
//	   fprintf(otch,"-session closed-"); 
//	   for(BR=0;BR<=23;BR++) fprintf(otch,"%d-",price2[BR]);fprintf(otch,"\n");
	   fclose(otch);
           ik=0;
           free(pw);
           return(0);
          };
       };   
    };
 /*---------------------------------------*/
 return(0);
}     

